import { InjectionKey } from 'vue';

export class DependencyInjector {
  // TODO: can we type this better?
  // eslint-disable-next-line
  private deps = new Map<InjectionKey<any>, any>();

  public provide<T>(key: InjectionKey<T>, dep: T): void {
    this.deps.set(key, dep);
  }

  public inject<T>(key: InjectionKey<T>): T | undefined {
    return this.deps.get(key) as T;
  }
}

export default new DependencyInjector();
